function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _iterable_to_array(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function _object_without_properties(source, excluded) {
    if (source == null) return {};
    var target = {}, sourceKeys, key, i;
    if (typeof Reflect !== "undefined" && Reflect.ownKeys) {
        sourceKeys = Reflect.ownKeys(source);
        for(i = 0; i < sourceKeys.length; i++){
            key = sourceKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
        return target;
    }
    target = _object_without_properties_loose(source, excluded);
    if (Object.getOwnPropertySymbols) {
        sourceKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceKeys.length; i++){
            key = sourceKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _object_without_properties_loose(source, excluded) {
    if (source == null) return {};
    var target = {}, sourceKeys = Object.getOwnPropertyNames(source), key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
    }
    return target;
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _to_array(arr) {
    return _array_with_holes(arr) || _iterable_to_array(arr) || _unsupported_iterable_to_array(arr) || _non_iterable_rest();
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
import React, { forwardRef } from "react";
import { useForkRef } from "../../../hooks";
import { base, CarouselWrapper, CarouselTrack } from "./Carousel.styles";
import { useCarousel } from "./useCarousel";
import { useDragScroll } from "./useDragScroll";
/**
 * Компонент для создания списков с прокруткой.
 */ export var carouselRoot = function carouselRoot(Root) {
    return /*#__PURE__*/ forwardRef(function(_0, _1) {
        var _ref = [
            _0,
            _1
        ], _ref1 = _to_array(_ref), _ref2 = _ref1[0], _rest = _ref1.slice(1), _ref_index = _ref2.index, index = _ref_index === void 0 ? 0 : _ref_index, _ref_scrollSnapType = _ref2.scrollSnapType, scrollSnapType = _ref_scrollSnapType === void 0 ? 'mandatory' : _ref_scrollSnapType, scrollAlign = _ref2.scrollAlign, detectActive = _ref2.detectActive, detectThreshold = _ref2.detectThreshold, scaleCallback = _ref2.scaleCallback, scaleResetCallback = _ref2.scaleResetCallback, onIndexChange = _ref2.onIndexChange, paddingStart = _ref2.paddingStart, paddingEnd = _ref2.paddingEnd, children = _ref2.children, _ref_ariaLive = _ref2.ariaLive, ariaLive = _ref_ariaLive === void 0 ? 'off' : _ref_ariaLive, _ref_isDragScrollDisabled = _ref2.isDragScrollDisabled, isDragScrollDisabled = _ref_isDragScrollDisabled === void 0 ? false : _ref_isDragScrollDisabled, rest = _object_without_properties(_ref2, [
            "index",
            "scrollSnapType",
            "scrollAlign",
            "detectActive",
            "detectThreshold",
            "scaleCallback",
            "scaleResetCallback",
            "onIndexChange",
            "paddingStart",
            "paddingEnd",
            "children",
            "ariaLive",
            "isDragScrollDisabled"
        ]), _rest1 = _sliced_to_array(_rest, 1), ref = _rest1[0];
        var axis = 'x';
        var _useCarousel = useCarousel({
            index: index,
            axis: axis,
            scrollAlign: scrollAlign,
            detectActive: detectActive,
            detectThreshold: detectThreshold,
            scaleCallback: scaleCallback,
            scaleResetCallback: scaleResetCallback,
            onIndexChange: onIndexChange
        }), scrollRef = _useCarousel.scrollRef, trackRef = _useCarousel.trackRef;
        var handleRef = useForkRef(scrollRef, ref);
        useDragScroll(scrollRef, isDragScrollDisabled);
        return /*#__PURE__*/ React.createElement(Root, {
            index: index
        }, /*#__PURE__*/ React.createElement(CarouselWrapper, _object_spread({
            ref: handleRef,
            scrollSnapType: scrollSnapType
        }, rest), /*#__PURE__*/ React.createElement(CarouselTrack, {
            ref: trackRef,
            paddingStart: paddingStart,
            paddingEnd: paddingEnd,
            "aria-live": ariaLive
        }, children)));
    });
};
export var carouselConfig = {
    name: 'Carousel',
    tag: 'div',
    layout: carouselRoot,
    base: base,
    variations: {},
    defaults: {}
};
